diff options
author | Raghavendra Talur <rtalur@redhat.com> | 2015-11-24 18:18:01 +0530 |
---|---|---|
committer | Raghavendra Talur <rtalur@redhat.com> | 2015-12-28 00:50:36 -0800 |
commit | 78305ce9604329250dd4a9f2335587957d71c701 (patch) | |
tree | 5222b7e08cc23fd62b7deeb221812a0c111451d8 /run-tests-in-vagrant.sh | |
parent | 7ab8a1a3f4510a284b1686302624ec4252c95a6f (diff) |
tests: Introduce a Vagrant VM based test environment
This introduces a mechanism using which a developer
could easily test the Gluster code in a VM environment.
Also, it will help bring uniformity in the environments
used by various developers.
How to use:
1. git checkout -b custom-branch-name
2. Make changes
3. Execute ./run-tests-in-vagrant.sh
What happens in the background:
1. A new directory is created:
tests/vagrant/vagrant-custom-branch-name
It will serve as the Vagrant dir which has the
Vagrantfile and related ansible playbooks.
The VM is started using Vagrant and provisioned
using ansible.
2. The source dir is recursively copied over to the
VM under /home/vagrant/glusterfs.
3. Gluster is source installed in VM.
What happens in the foreground:
1. run-tests.sh is executed in VM using ssh and output is displayed
in the same terminal with option to use ctrl-c to interrupt the test
midway. The VM would still persist and you could ssh into it.
Also, you can checkout a different branch elsewhere and execute
run-tests-in-vagrant.sh there to get another VM which would
execute tests on that code.
If you wish to make some changes in the code, you could:
a. Change the code in host and run the script again to repeat
the whole process.
OR
b. vagrant ssh into the VM and make the changes in the VM.
Co-authored-by: Kaushal M <kaushal@redhat.com>
Co-authored-by: Michael Adam <obnox@samba.org>
Change-Id: Ic87801172c8b614cdecbdf2a765e1b3370a5faf7
BUG: 1291537
Signed-off-by: Michael Adam <obnox@samba.org>
Signed-off-by: Raghavendra Talur <rtalur@redhat.com>
Reviewed-on: http://review.gluster.org/12753
Tested-by: Gluster Build System <jenkins@build.gluster.com>
Reviewed-by: Niels de Vos <ndevos@redhat.com>
Diffstat (limited to 'run-tests-in-vagrant.sh')
-rwxr-xr-x | run-tests-in-vagrant.sh | 126 |
1 files changed, 126 insertions, 0 deletions
diff --git a/run-tests-in-vagrant.sh b/run-tests-in-vagrant.sh new file mode 100755 index 00000000000..00ec99a4eb8 --- /dev/null +++ b/run-tests-in-vagrant.sh @@ -0,0 +1,126 @@ +#!/bin/bash + +############################################################################### +# TODO: Provide an option parser; may be getopts. # +# TODO: Allow subset of tests to be executed when VM starts. # +# TODO: Provide option to destroy the VM. # +############################################################################### + +function force_location() +{ + current_dir=$(dirname $0); + + if [ ! -f ${current_dir}/tests/vagrant/vagrant-template/Vagrantfile ]; then + echo "Aborting." + echo + echo "The tests/vagrant subdirectory seems to be missing." + echo + echo "Please correct the problem and try again." + echo + exit 1 + fi +} + +function vagrant_check() +{ + vagrant -v; + + if [ $? -ne 0 ]; then + echo "Aborting" + echo "Vagrant not found. Please install Vagrant and try again." + exit 1 + else + echo "Found Vagrant, continuing...." + echo + fi +} + +function ansible_check() +{ + ansible --version; + + if [ $? -ne 0 ]; then + echo "Aborting" + echo "Ansible not found. Please install Ansible and try again." + exit 1 + else + echo "Found Ansible, continuing...." + echo + fi +} + +force_location + +echo "Testing for Vagrant...." +vagrant_check +echo +echo + +echo "Testing for Ansible...." +ansible_check +echo +echo + +BRANCHNAME=`git rev-parse --abbrev-ref HEAD` +echo "Copying tests/vagrant/vagrant-template dir to tests/vagrant/$BRANCHNAME" +mkdir -p tests/vagrant/$BRANCHNAME +cp -R tests/vagrant/vagrant-template/* tests/vagrant/$BRANCHNAME +echo "Change dir to vagrant dir: tests/vagrant/$BRANCHNAME" +cd tests/vagrant/$BRANCHNAME +echo "Working directory is $PWD" +echo +echo + +echo "Doing vagrant up...." +vagrant up || { echo "vagrant up failed, exiting...."; exit 1; } +echo +echo + + +echo "Vagrant up successfull" +echo +echo + + +vagrant ssh-config > ssh_config + +echo "Copying source code from host machine to VM" +rsync -az -e "ssh -F ssh_config" "../../../." vagrant-testVM:/home/vagrant/glusterfs +#scp -r -F ssh_config "./../../../." vagrant-testVM:/home/vagrant/glusterfs +echo "Copied." +echo +echo + +vagrant ssh -c 'cd /home/vagrant/glusterfs ; ./autogen.sh' -- -t +echo +echo + +vagrant ssh -c 'cd /home/vagrant/glusterfs ; \ + CFLAGS="-g -O0 -Werror -Wall -Wno-error=cpp -Wno-error=maybe-uninitialized" \ + ./configure \ + --prefix=/usr \ + --exec-prefix=/usr \ + --bindir=/usr/bin \ + --sbindir=/usr/sbin \ + --sysconfdir=/etc \ + --datadir=/usr/share \ + --includedir=/usr/include \ + --libdir=/usr/lib64 \ + --libexecdir=/usr/libexec \ + --localstatedir=/var \ + --sharedstatedir=/var/lib \ + --mandir=/usr/share/man \ + --infodir=/usr/share/info \ + --libdir=/usr/lib64 \ + --enable-debug' -- -t +echo +echo + + +vagrant ssh -c 'cd /home/vagrant/glusterfs; sudo make install' -- -t +echo +echo + +vagrant ssh -c 'cd /home/vagrant/glusterfs; sudo ./run-tests.sh' -- -t +echo +echo |